#include <node.h>
#include <uv.h>
#include <string>

#include <Windows.h>

using namespace v8;

/*
    Add methods
*/
void nodewall_set(const FunctionCallbackInfo<Value>& args) {
    Isolate* isolate = Isolate::GetCurrent();

    // Check arguments
    if (args.Length() < 1) {
        isolate->ThrowException(Exception::TypeError(
            String::NewFromUtf8(isolate, "Wrong number of arguments")));
    } else if (!args[0]->IsString()) {
        isolate->ThrowException(Exception::TypeError(
            String::NewFromUtf8(isolate, "Wrong arguments")));
    }

    // Get string
    char* str = (char*)std::string(*v8::String::Utf8Value(args[0]->ToString())).c_str();
    
    // Set wallpaper
    int result = SystemParametersInfoA(SPI_SETDESKWALLPAPER, 0, str, SPIF_UPDATEINIFILE);
    
    // Return
    args.GetReturnValue().Set(result ? true : false);
}

/*
    Register module
*/
void RegisterModule(Handle<Object> target) {
    // Add properties to target
    NODE_SET_METHOD(target, "set", nodewall_set);
}

// Register the module with node.
NODE_MODULE(addon, RegisterModule);
